; 
    include \masm32\include\masm32rt.inc
    .586 

    IdleThread  PROTO
    CtrlHandler PROTO :DWORD
; 
    .data
        startCount  dq 0
        idleCount   dq 0
        totalCount  dq 0
        threadID    dd 0
        hThread     dd 0
        hTimer      dd 0
        exitFlag    dd 0
        temp        dd 0
        exitCode    dd 0
    .code
; 
start:
; 

    ;invoke GetCurrentProcess
    ;invoke SetPriorityClass, eax, HIGH_PRIORITY_CLASS

    invoke CreateThread,NULL,0,ADDR IdleThread,
        NULL,CREATE_SUSPENDED,ADDR threadID
    mov   hThread,eax

    invoke SetThreadPriority,hThread,THREAD_PRIORITY_IDLE

    invoke SetConsoleCtrlHandler,ADDR CtrlHandler,TRUE
    
    invoke CreateWaitableTimer,NULL,FALSE,NULL
    mov   hTimer, eax

    ; --------------------------------------------------
    ; ADDR temp used here because 0 will not work, even
    ; though the due time is apparently ignored when a
    ; timer period (here set to 500 ms) is specified.
    ; --------------------------------------------------
    invoke SetWaitableTimer,hTimer,ADDR temp,500,NULL,NULL,0

    rdtsc
    mov   DWORD PTR startCount,     eax
    mov   DWORD PTR startCount[4],  edx

    invoke ResumeThread,hThread

    .WHILE (TRUE)

        invoke WaitForSingleObject,hTimer,1000

        rdtsc
        sub   eax, DWORD PTR startCount
        sbb   edx, DWORD PTR startCount[4]

        mov   DWORD PTR totalCount,    eax
        mov   DWORD PTR totalCount[4], edx

        fild  idleCount
        fild  totalCount
        fdiv                    ; idle cycles / total cycles
        fld8  100.0
        fmul                    ; convert to percent
        fistp temp

        mov   eax, 100          ; calc non-idle percent
        sub   eax, temp

        print ustr$(eax),13,10

        ; -------------------------------------------
        ; Reinitialize for the next sampling period.
        ; -------------------------------------------
        rdtsc
        mov   DWORD PTR startCount,     eax
        mov   DWORD PTR startCount[4],  edx
        mov   DWORD PTR idleCount,      0
        mov   DWORD PTR idleCount[4],   0

    .ENDW

    ;mov   eax, input(13,10,"Press enter to exit...")
    ;exit

; 

CtrlHandler proc ctrlType:DWORD

    .IF (ctrlType == CTRL_CLOSE_EVENT)

        invoke SetThreadPriority,hThread,THREAD_PRIORITY_HIGHEST
        inc   exitFlag

        .WHILE (exitCode == STILL_ACTIVE)
            invoke GetExitCodeThread,hThread,ADDR exitCode
        .ENDW

    .ENDIF

    invoke CloseHandle,hThread

    ; ----------------------------------------------
    ; Exit directly from this procedure to avoid a
    ; "Windows cannot end this program..." warning.
    ; ----------------------------------------------
    exit

CtrlHandler endp

; 

IdleThread proc uses ebx

    ; --------------------------------------------------
    ; If the cycle count for the current loop is below
    ; a threshold value, assume the count represents
    ; the CPU idle time, and add it to the idle count
    ; for the current sampling period.
    ;
    ; Because a task switch could occur at any point in
    ; the loop, each task switch could introduce an
    ; error as large as the cycle count for the loop
    ; instructions, but this should be negligibly small
    ; compared to the cycle count for a time slice.
    ;
    ; The threshold value needs to be somewhat larger
    ; than the worst-case cycle count for the loop
    ; instructions.
    ; --------------------------------------------------

    .WHILE (exitFlag == 0)

        rdtsc
        push  eax
        push  edx
        sub   eax, ebx
        sbb   edx, ecx
        .IF (edx == 0 && eax < 200)
            add   DWORD PTR idleCount,    eax
            adc   DWORD PTR idleCount[4], edx
        .ENDIF
        pop   ecx               ; save for next loop
        pop   ebx

    .ENDW

    ret

IdleThread endp

; 
end start
 